package com.hai.dao;

import com.hai.entity.HighCouponPackageDetails;
import com.hai.entity.HighCouponPackageDetailsExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighCouponPackageDetailsMapper extends HighCouponPackageDetailsMapperExt {
    @SelectProvider(type=HighCouponPackageDetailsSqlProvider.class, method="countByExample")
    long countByExample(HighCouponPackageDetailsExample example);

    @DeleteProvider(type=HighCouponPackageDetailsSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighCouponPackageDetailsExample example);

    @Delete({
        "delete from high_coupon_package_details",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_coupon_package_details (coupon_package_id, coupon_id, ",
        "coupon_name, num, ",
        "created_user_id, created_time, ",
        "updated_user_id, updated_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{couponPackageId,jdbcType=INTEGER}, #{couponId,jdbcType=INTEGER}, ",
        "#{couponName,jdbcType=VARCHAR}, #{num,jdbcType=INTEGER}, ",
        "#{createdUserId,jdbcType=INTEGER}, #{createdTime,jdbcType=TIMESTAMP}, ",
        "#{updatedUserId,jdbcType=INTEGER}, #{updatedTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighCouponPackageDetails record);

    @InsertProvider(type=HighCouponPackageDetailsSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighCouponPackageDetails record);

    @SelectProvider(type=HighCouponPackageDetailsSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="coupon_package_id", property="couponPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_id", property="couponId", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighCouponPackageDetails> selectByExample(HighCouponPackageDetailsExample example);

    @Select({
        "select",
        "id, coupon_package_id, coupon_id, coupon_name, num, created_user_id, created_time, ",
        "updated_user_id, updated_time, `status`, ext_1, ext_2, ext_3",
        "from high_coupon_package_details",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="coupon_package_id", property="couponPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_id", property="couponId", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighCouponPackageDetails selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighCouponPackageDetailsSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighCouponPackageDetails record, @Param("example") HighCouponPackageDetailsExample example);

    @UpdateProvider(type=HighCouponPackageDetailsSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighCouponPackageDetails record, @Param("example") HighCouponPackageDetailsExample example);

    @UpdateProvider(type=HighCouponPackageDetailsSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighCouponPackageDetails record);

    @Update({
        "update high_coupon_package_details",
        "set coupon_package_id = #{couponPackageId,jdbcType=INTEGER},",
          "coupon_id = #{couponId,jdbcType=INTEGER},",
          "coupon_name = #{couponName,jdbcType=VARCHAR},",
          "num = #{num,jdbcType=INTEGER},",
          "created_user_id = #{createdUserId,jdbcType=INTEGER},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "updated_user_id = #{updatedUserId,jdbcType=INTEGER},",
          "updated_time = #{updatedTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighCouponPackageDetails record);
}