package com.hai.dao;

import com.hai.entity.HighCouponPackageRecord;
import com.hai.entity.HighCouponPackageRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighCouponPackageRecordMapper extends HighCouponPackageRecordMapperExt {
    @SelectProvider(type=HighCouponPackageRecordSqlProvider.class, method="countByExample")
    long countByExample(HighCouponPackageRecordExample example);

    @DeleteProvider(type=HighCouponPackageRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighCouponPackageRecordExample example);

    @Delete({
        "delete from high_coupon_package_record",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_coupon_package_record (coupon_package_title, coupon_package_id, ",
        "using_attribution, company_id, ",
        "order_id, child_order_id, ",
        "price, record_no, ",
        "sales_type, user_id, ",
        "created_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{couponPackageTitle,jdbcType=VARCHAR}, #{couponPackageId,jdbcType=INTEGER}, ",
        "#{usingAttribution,jdbcType=INTEGER}, #{companyId,jdbcType=INTEGER}, ",
        "#{orderId,jdbcType=INTEGER}, #{childOrderId,jdbcType=INTEGER}, ",
        "#{price,jdbcType=DECIMAL}, #{recordNo,jdbcType=VARCHAR}, ",
        "#{salesType,jdbcType=INTEGER}, #{userId,jdbcType=INTEGER}, ",
        "#{createdTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighCouponPackageRecord record);

    @InsertProvider(type=HighCouponPackageRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighCouponPackageRecord record);

    @SelectProvider(type=HighCouponPackageRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="coupon_package_title", property="couponPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="coupon_package_id", property="couponPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="using_attribution", property="usingAttribution", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.INTEGER),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.INTEGER),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.INTEGER),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="record_no", property="recordNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_type", property="salesType", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighCouponPackageRecord> selectByExample(HighCouponPackageRecordExample example);

    @Select({
        "select",
        "id, coupon_package_title, coupon_package_id, using_attribution, company_id, ",
        "order_id, child_order_id, price, record_no, sales_type, user_id, created_time, ",
        "`status`, ext_1, ext_2, ext_3",
        "from high_coupon_package_record",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="coupon_package_title", property="couponPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="coupon_package_id", property="couponPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="using_attribution", property="usingAttribution", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.INTEGER),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.INTEGER),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.INTEGER),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="record_no", property="recordNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_type", property="salesType", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighCouponPackageRecord selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighCouponPackageRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighCouponPackageRecord record, @Param("example") HighCouponPackageRecordExample example);

    @UpdateProvider(type=HighCouponPackageRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighCouponPackageRecord record, @Param("example") HighCouponPackageRecordExample example);

    @UpdateProvider(type=HighCouponPackageRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighCouponPackageRecord record);

    @Update({
        "update high_coupon_package_record",
        "set coupon_package_title = #{couponPackageTitle,jdbcType=VARCHAR},",
          "coupon_package_id = #{couponPackageId,jdbcType=INTEGER},",
          "using_attribution = #{usingAttribution,jdbcType=INTEGER},",
          "company_id = #{companyId,jdbcType=INTEGER},",
          "order_id = #{orderId,jdbcType=INTEGER},",
          "child_order_id = #{childOrderId,jdbcType=INTEGER},",
          "price = #{price,jdbcType=DECIMAL},",
          "record_no = #{recordNo,jdbcType=VARCHAR},",
          "sales_type = #{salesType,jdbcType=INTEGER},",
          "user_id = #{userId,jdbcType=INTEGER},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighCouponPackageRecord record);
}