package com.hai.service;

import com.hai.entity.HighCouponPackage;
import com.hai.entity.HighCouponPackageDetails;

import java.util.List;
import java.util.Map;

/**
 * @serviceName HighCouponPackageDetailsService.java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 优惠券包详情服务
 * @createTime 3:11 下午 2021/11/25
 **/
public interface HighCouponPackageDetailsService {

    /**
    * @Author Sum1Dream
    * @name getCouponPackageDetailsList.java
    * @Description // 获取优惠券包详情卢列表
    * @Date 3:35 下午 2021/11/25
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return java.util.List<com.hai.entity.HighCouponPackageDetails>
    */
    List<HighCouponPackageDetails> getCouponPackageDetailsList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @name findDetailsById.java
    * @Description // 获取详情
    * @Date 3:36 下午 2021/11/25
    * @Param [java.lang.Integer]
    * @return com.hai.entity.HighCouponPackageDetails
    */
    HighCouponPackageDetails findDetailsById(Integer id);

    /**
     * @Author Sum1Dream
     * @name insertCouponPackageDetails.java
     * @Description // 新增优惠券包详情信息
     * @Date 12:07 下午 2021/11/25
     * @Param [com.hai.entity.HighCouponPackage]
     * @return void
     */
    void insertCouponPackageDetails(HighCouponPackageDetails highCouponPackageDetails);

    /**
     * @Author Sum1Dream
     * @name updateCouponPackageDetails.java
     * @Description // 更新优惠券包详情信息
     * @Date 12:07 下午 2021/11/25
     * @Param [com.hai.entity.HighCouponPackage]
     * @return void
     */
    void updateCouponPackageDetails(HighCouponPackageDetails highCouponPackageDetails);

}
