package com.hai.service;

import com.hai.entity.HighCouponPackage;
import com.hai.entity.HighOrderPre;

import java.util.List;
import java.util.Map;

/**
 * @serviceName HighCouponPackageService.java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 优惠券包接口服务
 * @createTime 11:31 上午 2021/11/25
 **/
public interface HighCouponPackageService {

    /**
    * @Author Sum1Dream
    * @name getCouponPackageList.java
    * @Description // 获取优惠券包列表
    * @Date 11:34 上午 2021/11/25
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return java.util.List<com.hai.entity.HighCouponPackage>
    */
    List<HighCouponPackage> getCouponPackageList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @name findCouponPackageById.java
    * @Description //
    * @Date 11:35 上午 2021/11/25
    * @Param [java.lang.Integer]
    * @return com.hai.entity.HighCouponPackage
    */
    HighCouponPackage findCouponPackageById(Integer id);

    /**
    * @Author Sum1Dream
    * @name insertCouponPackage.java
    * @Description // 新增优惠券包信息
    * @Date 12:07 下午 2021/11/25
    * @Param [com.hai.entity.HighCouponPackage]
    * @return void
    */
    void insertCouponPackage(HighCouponPackage highCouponPackage);

    /**
    * @Author Sum1Dream
    * @name updateCouponPackage.java
    * @Description // 新增优惠券包信息
    * @Date 12:07 下午 2021/11/25
    * @Param [com.hai.entity.HighCouponPackage]
    * @return void
    */
    void updateCouponPackage(HighCouponPackage highCouponPackage);


}
